shader_type canvas_item;
render_mode blend_disabled;

uniform sampler2D u_brush_texture;
uniform vec2 u_range;
uniform float u_factor = 1.0;

void fragment() {
	float brush_value = texture(u_brush_texture, SCREEN_UV).r;
	
	float src_h = texture(TEXTURE, UV).r;
	float h = src_h + u_factor * brush_value;
	h = clamp(h, u_range.x, u_range.y);
	COLOR = vec4(h, 0.0, 0.0, 1.0);
}
